<h4>Formularios <small> Aproximacion por Reactive </small></h4>
<hr>
<form autocomplete="off" [formGroup]="form" (ngSubmit)="save()">

    <div>

        <div class="form-group row">
            <label class="col-2 col-form-label">Nombre</label>
            <div class="col">

                <!-- formControlName -> para asignaar el valor -->
                <input class="form-control" type="text" placeholder="Nombre" formControlName="name" [class.is-invalid]="isInvalidName">
                <small *ngIf="isInvalidName" class="text-danger">Ingrese 5 letras</small>
            </div>

        </div>

        <div class="form-group row">
            <label class="col-2 col-form-label">Apellido</label>
            <div class="col">

                <input class="form-control" type="text" placeholder="Apellido" formControlName="lastname" [class.is-invalid]="isInvalidLastName">
                <small *ngIf="isInvalidLastName" class="text-danger">Ingrese 5 letras</small>
            </div>
        </div>

    </div>

    <div class="form-group row">
        <label class="col-2 col-form-label">Correo</label>
        <div class="col">

            <input class="form-control" type="email" placeholder="Correo electrónico" formControlName="email" [class.is-invalid]="isInvalidEmail">
            <small *ngIf="isInvalidEmail" class="text-danger">Ingrese correctamente Email</small>
        </div>
    </div>


    <div class="form-group row">
        <label class="col-2 col-form-label">Usuario</label>
        <div class="col">

            <input class="form-control" type="text" placeholder="usuario" formControlName="user" [class.is-invalid]="isInvalidUsuario">
            <small *ngIf="isInvalidUsuario" class="text-danger">Usuario Existe</small>
        </div>
    </div>


    <div class="form-group row">
        <label class="col-2 col-form-label">Contraseña</label>
        <div class="col">

            <input class="form-control" type="password" placeholder="password" formControlName="pass1" [class.is-invalid]="isInvalidPass1">
            <!-- <small *ngIf="isInvalidEmail" class="text-danger">Ingrese correctamente Email</small> -->
        </div>
    </div>

    <div class="form-group row">
        <label class="col-2 col-form-label">Confirmar contraseña</label>
        <div class="col">

            <input class="form-control" type="password" placeholder="Repita password" formControlName="pass2" [class.is-invalid]="isInvalidPass2">
            <!-- <small *ngIf="isInvalidEmail" class="text-danger">Ingrese correctamente Email</small> -->
        </div>
    </div>





    <div class="form-group row" formGroupName="direccion">
        <label class="col-2 col-form-label">Direccion</label>
        <div class="form-row col">

            <div class="col">

                <input class="form-control" type="text" placeholder="distrito" formControlName="distrito" [class.is-invalid]="isInvalidDistrito">
                <small *ngIf="isInvalidDistrito" class="text-danger">Ingrese 5 letras</small>
            </div>

            <div class="col">

                <input class="form-control" type="text" placeholder="ciudad" formControlName="ciudad" [class.is-invalid]="isInvalidCiudad">
                <small *ngIf="isInvalidCiudad" class="text-danger">Ingrese 5 letras</small>
            </div>



        </div>
    </div>

    <div class="form-group row">

        <div class="col">

            <table class="table">
                <thead class="thead-dark">
                    <tr>
                        <th>Id</th>
                        <th>Pasatiempo</th>
                        <th>Borrar</th>
                    </tr>
                </thead>
                <tbody formArrayName="pasatiempos">
                    <!-- pasatiempos.control >  pasatiempos es un metodo -->
                    <tr *ngFor="let control of pasatiempos.controls; let i = index">
                        <td>{{ i + 1 }}</td>
                        <td>
                            <input class="form-control" type="text" [formControlName]="i">
                        </td>
                        <td>
                            <button class="btn btn-danger" type="button" (click)=borrarPasatiempo(i)>Borrar</button>
                        </td>
                    </tr>
                </tbody>
            </table>
            <button class="btn btn-primary btn-block" type="button" (click)="agregarPasatiempo()"> + Agregar </button>

        </div>
    </div>



    <div class="form-group row">
        <label class="col-2 col-form-label">&nbsp;</label>
        <div class="input-group col md-8">
            <button type="submit" class="btn btn-outline-primary btn-block">
        Guardar
      </button>
        </div>
    </div>

</form>


<hr>
<pre>
    Estado del formulario: {{ form.valid }}
    <br>
    Estado: {{ form.status }}
</pre>

<pre>
    {{ form.value | json }}
</pre>